package tech.nevets.igformatter;

import spark.Request;
import spark.Response;
import spark.Route;

import javax.imageio.ImageIO;
import javax.servlet.MultipartConfigElement;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

public class GenerateRoute implements Route {
    @Override
    public Object handle(Request req, Response res) throws Exception {
        req.attribute("org.eclipse.jetty.multipartConfig", new MultipartConfigElement("./temp"));
        try (InputStream is = req.raw().getPart("image").getInputStream()) {
            BufferedImage img = ImageIO.read(is);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();

            int color;
            boolean customDimensions;
            int width;
            int height;
            try {
                color = Integer.parseInt(req.queryParams("color"));
                customDimensions = Boolean.parseBoolean(req.queryParams("customDimensions"));
                width = Integer.parseInt(req.queryParams("width"));
                height = Integer.parseInt(req.queryParams("height"));
            } catch (final Exception e) {
                res.type("plain/text");
                res.status(400);
                return "Error in sent parameters: " + e.getMessage();
            }

            ImageIO.write(Images.renderImage(img, color, customDimensions, width, height), "png", baos);

            res.type("image/png");
            return baos.toByteArray();
        }
    }
}
