package tech.nevets.igformatter;

import java.awt.*;
import java.awt.image.BufferedImage;

public class Images {
    public static BufferedImage renderImage(BufferedImage img, int color, boolean customDimensions, int customWidth, int customHeight) {
        BufferedImage image = generateBackground(color);
        Graphics2D g = image.createGraphics();

        int width;
        int height;
        int xPos;
        int yPos;

        if (customDimensions) {
            width = customWidth;
            height = customHeight;
            xPos = 0;
            yPos = 0;
        } else {
            int oldWidth = img.getWidth();
            int oldHeight = img.getHeight();

            if (oldWidth > oldHeight) {
                width = 1048;
                height = (width * oldHeight) / oldWidth;
                xPos = 16;
                yPos = (1080 - height) / 2;
            } else if (oldHeight > oldWidth) {
                height = 1048;
                width = (oldWidth * height) / oldHeight;
                xPos = (1080 - width) / 2;
                yPos = 16;
            } else {
                width = 1048;
                height = 1048;
                xPos = 16;
                yPos = 16;
            }
        }

        g.drawImage(resizeImage(img, width, height), xPos, yPos, width, height, null);
        g.dispose();

        return image;
    }

    private static BufferedImage resizeImage(BufferedImage rawImage, int width, int height) {
        BufferedImage resizedImage = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
        Graphics2D g = resizedImage.createGraphics();
        g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g.drawImage(rawImage, 0, 0, width, height, null);
        g.dispose();
        return resizedImage;
    }

    public static BufferedImage generateBackground(int color) {
        BufferedImage image = new BufferedImage(1080, 1080, BufferedImage.TYPE_INT_ARGB);
        Graphics2D g2d = image.createGraphics();
        g2d.setColor(new Color(color));
        g2d.setPaint(new Color(color));
        g2d.fillRect(0, 0, 1080, 1080);
        g2d.dispose();
        return image;
    }
}
